//地球の磁場2次元
#include <stdio.h>
#include <math.h>

#define N 21 //分割数21

int main(void) {
    double Btheta, Br;
    double mu0=1.0, m=1.0, r, sintheta, costheta;
    double h=20.0/(N-1); // 1.0
    double x, y, Bx, By;
    double omega=0.0; // 23.4
    double rotate[2][2];
    rotate[0][0]=cos(omega*M_PI/180);
    rotate[0][1]=-sin(omega*M_PI/180);
    rotate[1][0]=sin(omega*M_PI/180);
    rotate[1][1]=cos(omega*M_PI/180);
    double x_new, y_new, Bx_new, By_new;

    FILE *fp;
    fp=fopen("aurora2.txt", "w");
    fprintf(fp, "#x\t\ty\t\tBx\t\tBy\n");

    for (int j=0; j<N; j++) {
        for (int i=0; i<N; i++) {
            x=-10.0+h*i;
            y=10.0-h*j;
            x_new=x*rotate[0][0]+y*rotate[0][1];
            y_new=x*rotate[1][0]+y*rotate[1][1];
            x=x_new;
            y=y_new;
            r=x*x+y*y;
            r=sqrt(r);
            if (r!=0) {
                sintheta=x/r;
                costheta=y/r;
                Btheta=mu0*m*sintheta/(4*M_PI*r*r*r);
                Br=mu0*2*m*costheta/(4*M_PI*r*r*r);
            } else {
                sintheta=0.0;
                costheta=0.0;
                Btheta=0.0;
                Br=0.0;
            }
            Bx=Btheta*costheta+Br*sintheta;
            By=Btheta*(-sintheta)+Br*costheta;

            //逆回転行列
            x_new=x*rotate[0][0]+y*rotate[1][0];
            y_new=x*rotate[0][1]+y*rotate[1][1];
            Bx_new=Bx*rotate[0][0]+By*rotate[1][0];
            By_new=Bx*rotate[0][1]+By*rotate[1][1];
            x=x_new;
            y=y_new;
            Bx=Bx_new;
            By=By_new;
            fprintf(fp, "%f\t%f\t%f\t%f\n", x, y, Bx*(-1), By*(-1));
        }
    }

    fclose(fp);

    return 0;
}
